from __future__ import print_function
from flask import Flask, render_template, request
import datetime
import can
import time
from time import sleep
from can_MK import *
from can_func import *
app = Flask(__name__)


# Create a dictionary called ports to store the port number, name, and port state:
ports = {
   0 : {'name' : 'port 0 (1)', 'state' : PORTSTATE},
   1 : {'name' : 'port 1 (2)', 'state' : PORTSTATE},
   2 : {'name' : 'port 2 (3)', 'state' : PORTSTATE},
   3 : {'name' : 'port 3 (4)', 'state' : PORTSTATE},
   4 : {'name' : 'port 4 (5)', 'state' : PORTSTATE},
   5 : {'name' : 'port 5 (6)', 'state' : PORTSTATE},
   6 : {'name' : 'port 6 (7)', 'state' : PORTSTATE},
   7 : {'name' : 'port 7 (8)', 'state' : PORTSTATE} 
   }

# Set each pin as an output and make it low:
## for port in ports:
##   0x01
#   GPIO.setup(pin, GPIO.OUT)
#   GPIO.output(pin, GPIO.LOW)

@app.route("/")
def main():
    bus = can.interface.Bus()                                       # init CAN bus
    # For each port, read the port state and store it in the ports dictionary:
    for port in ports:
        ports[port]['state'] = request_status(bus, 0x01, int(port))          # bus, target_ID, port
        sleep(0.05)
    # Put the pin dictionary into the template data dictionary:
    templateData = {
        'ports' : ports
        }
    # Pass the template data into the template main.html and return it to the user
    return render_template('main.html', **templateData)

# The function below is executed when someone requests a URL with the pin number and action in it:
@app.route("/<changePort>/<action>")
def action(changePort, action):
    # Convert the port from the URL into an integer:
    changePort = int(changePort)
    # Get the device name for the pin being changed:
    deviceName = ports[changePort]['name']
    bus = can.interface.Bus()
    # If the action part of the URL is "on," execute the code indented below:
    if action == "on":
        # Set the port high:
        print("send ON ", T_ON)
        request_action(bus, 0x01, changePort, T_ON)
#       GPIO.output(changePin, GPIO.HIGH)
        # Save the status message to be passed into the template:
        message = "Turned " + deviceName + " on."
    if action == "off":
        print("send OFF ", T_OFF)
        request_action(bus, 0x01, changePort, T_OFF)
#       GPIO.output(changePin, GPIO.LOW)
        message = "Turned " + deviceName + " off."
    if action == "toggle":
        request_action(bus, 0x01, changePort, T_TOGGLE)
        # Read the pin and set it to whatever it isn't (that is, toggle it):
        #GPIO.output(changePin, not GPIO.input(changePin))
        message = "Toggled " + deviceName + "."

    # For each pin, read the pin state and store it in the pins dictionary:
    for port in ports:
        ports[port]['state'] = request_status(bus, 0x01, int(port))
        sleep(0.05)
    # Along with the pin dictionary, put the message into the template data dictionary:
    templateData = {
        'message' : message,
        'ports' : ports
    }

    return render_template('main.html', **templateData)

if __name__ == "__main__":
    app.run(host='0.0.0.0', port=80, debug=False)
